package golfCourse.agents.databaseAgent.handlers;

import golfCourse.agents.databaseAgent.DataBaseAgent;
import golfCourse.communication.services.RequestHandler;
import golfCourse.dao.GolfCourseDAO;
import jade.content.onto.basic.Action;
import jade.core.Agent;
import jade.core.behaviours.DataStore;
import jade.domain.FIPAAgentManagement.FailureException;
import jade.lang.acl.ACLMessage;
import jade.util.Logger;

import java.util.logging.Level;

import com.hp.hpl.jena.ontology.OntModel;

/**
 * Agent remove all data from database.
 */
public class ClearDatabaseHandler extends RequestHandler {
	
	private static Logger logger = Logger.getMyLogger(ClearDatabaseHandler.class.getName());
	
	private DataBaseAgent myAgent;
	private OntModel mDomain;
	private OntModel mGolfCoursesDB;
	private GolfCourseDAO dao;
	
	public ClearDatabaseHandler(Agent a, DataStore ds, Object requestKey,
			Object actKey, Object notificationKey) {
		super(a, ds, requestKey, actKey, notificationKey);
		myAgent = (DataBaseAgent) a;
		
	}

	protected final ACLMessage prepareResponse(ACLMessage request, Action act) throws FailureException {
		logger.info(myAgent.getLocalName() + " - clear database action");
		this.mDomain = myAgent.getDomainModel();
		this.mGolfCoursesDB = myAgent.getGolfCoursesDBModel();
		this.dao = new GolfCourseDAO(mDomain, mGolfCoursesDB);
		dao.removeAllData();
		logger.info(myAgent.getLocalName() + ": database is empty");
		// no response
		return null;
	}

}
