package golfCourse.agents.managerAgent.system.handlers;

import golfCourse.agents.managerAgent.ManagerAgent;
import golfCourse.agents.managerAgent.behaviours.ReceiveSystemErrorBehaviour;
import golfCourse.agents.searchAgent.handlers.FindGolfCoursesHandler;
import golfCourse.communication.ontology.MA_system_error_action;
import golfCourse.communication.services.RequestHandler;
import jade.content.onto.basic.Action;
import jade.core.Agent;
import jade.core.behaviours.DataStore;
import jade.domain.FIPAAgentManagement.FailureException;
import jade.lang.acl.ACLMessage;
import jade.util.Logger;

public class ReceiveSystemErrorHandler extends RequestHandler {

	private static Logger logger = Logger.getMyLogger(ReceiveSystemErrorHandler.class.getName());
	
	protected ManagerAgent myAgent;
	private String answer = null;
	private String customerAID = "";
	
	public ReceiveSystemErrorHandler(Agent a, DataStore ds, Object requestKey,
			Object actKey, Object notificationKey) {
		super(a, ds, requestKey, actKey, notificationKey);
		myAgent = (ManagerAgent) a;
	}

	protected final ACLMessage prepareResponse(ACLMessage request, Action act) throws FailureException {
		
		MA_system_error_action action = (MA_system_error_action)act.getAction();
		
		myAgent.addBehaviour(new ReceiveSystemErrorBehaviour(action.getError_message().getMessage(), myAgent));

		return null;
	}
}
