package golfCourse.agents.managerAgent.system.handlers;

import golfCourse.agents.managerAgent.ManagerAgent;
import golfCourse.agents.managerAgent.behaviours.ShowMessageBehaviour;
import golfCourse.communication.ontology.MA_show_error_message_action;
import golfCourse.communication.services.RequestHandler;
import jade.content.onto.basic.Action;
import jade.core.Agent;
import jade.core.behaviours.DataStore;
import jade.domain.FIPAAgentManagement.FailureException;
import jade.lang.acl.ACLMessage;
import jade.util.Logger;

public class ShowMessageHandler extends RequestHandler {

	private static Logger logger = Logger.getMyLogger(ShowMessageHandler.class.getName());
	
	protected ManagerAgent myAgent;
	
	public ShowMessageHandler(Agent a, DataStore ds, Object requestKey,
			Object actKey, Object notificationKey) {
		super(a, ds, requestKey, actKey, notificationKey);
		myAgent = (ManagerAgent) a;
	}

	protected final ACLMessage prepareResponse(ACLMessage request, Action act) throws FailureException {
		
		MA_show_error_message_action action = (MA_show_error_message_action)act.getAction();		
		myAgent.addBehaviour(new ShowMessageBehaviour(action.getMessage_().getMessage()));
		return null;
	}
}
