package golfCourse.agents.searchAgent;

import golfCourse.agents.searchAgent.handlers.CloseSystemHandler;
import golfCourse.agents.searchAgent.handlers.FindGolfCoursesHandler;
import golfCourse.communication.ontology.Close_system_action;
import golfCourse.communication.ontology.SA_return_golf_courses;
import golfCourse.communication.ontology.SA_search_golf_courses;
import golfCourse.communication.services.ActionDispatcher;
import jade.core.Agent;
import jade.domain.FIPAAgentManagement.NotUnderstoodException;
import jade.domain.FIPAAgentManagement.RefuseException;
import jade.lang.acl.ACLMessage;
import jade.lang.acl.MessageTemplate;
import jade.proto.AchieveREResponder;
import jade.proto.states.HandlerSelector;

public class SearchAgentResponder extends AchieveREResponder {

	public final String ACT_KEY = "__action" + hashCode();

	public SearchAgentResponder(Agent a, MessageTemplate mt) {
		super(a, mt);

		HandlerSelector selector = new ActionDispatcher(myAgent, getDataStore(), REQUEST_KEY, ACT_KEY);
		
		selector.registerHandler(SA_search_golf_courses.class.getName(),
				new FindGolfCoursesHandler(myAgent, getDataStore(), REQUEST_KEY, ACT_KEY, RESULT_NOTIFICATION_KEY));
		
		//SA_return_golf_courses
		selector.registerHandler(SA_return_golf_courses.class.getName(),
				new FindGolfCoursesHandler(myAgent, getDataStore(), REQUEST_KEY, ACT_KEY, RESULT_NOTIFICATION_KEY));

		selector.registerHandler(Close_system_action.class.getName(),
				new CloseSystemHandler(myAgent, getDataStore(), REQUEST_KEY, ACT_KEY, RESULT_NOTIFICATION_KEY));

		registerPrepareResultNotification(selector);
	}
	
    protected ACLMessage prepareResponse(ACLMessage request) throws NotUnderstoodException, RefuseException {
    	// Don't say AGREE or REFUSE exlipictly; no response means AGREE
        return null;
    }
}
