package golfCourse.dao;

import golfCourse.ontologies.jastor.contacts.Contacts;
import golfCourse.ontologies.jastor.golfCourse.GolfCourse;
import golfCourse.ontologies.jastor.location.AddressRecord;

import java.util.Iterator;

import com.ibm.adtech.jastor.JastorException;

public class DAOTools {

	public static Contacts copyProperties(Contacts newContact, Contacts oldContact) throws JastorException
	{
		newContact.setAddress(oldContact.getAddress());
		newContact.setLocation(oldContact.getLocation());
		newContact.setServiceType(oldContact.getServiceType());
		newContact.setTechnology(oldContact.getTechnology());
		newContact.setUse(oldContact.getUse());
		
		return newContact;
	}
	
	public static AddressRecord copyProperties(AddressRecord newAddress, AddressRecord oldAddress) throws JastorException
	{
		newAddress.setCity(oldAddress.getCity());
		newAddress.setCountry(oldAddress.getCountry());
		newAddress.setFlatNumber(oldAddress.getFlatNumber());
		newAddress.setFullAddress(oldAddress.getFullAddress());
		newAddress.setHouseNumber(oldAddress.getHouseNumber());
		newAddress.setRegion(oldAddress.getRegion());
		newAddress.setStreet(oldAddress.getStreet());
		newAddress.setZip(oldAddress.getZip());
		return newAddress;
	}
	
	public static GolfCourse copyProperties(GolfCourse newGolfCourse, GolfCourse oldGolfCourse) throws JastorException 
	{
		newGolfCourse.setAvailCaddy(oldGolfCourse.getAvailCaddy());
		newGolfCourse.setContactInfo(oldGolfCourse.getContactInfo());
		newGolfCourse.setGrassType(oldGolfCourse.getGrassType());
		newGolfCourse.setHomePage(oldGolfCourse.getHomePage());
		newGolfCourse.setId(oldGolfCourse.getId());
		newGolfCourse.setMetalSpikes(oldGolfCourse.getMetalSpikes());
		newGolfCourse.setName(oldGolfCourse.getName());
		newGolfCourse.setPermCart(oldGolfCourse.getPermCart());
		newGolfCourse.setSinglesConfirmed(oldGolfCourse.getSinglesConfirmed());
		newGolfCourse.setSlope(oldGolfCourse.getSlope());
		newGolfCourse.setYardage(oldGolfCourse.getYardage());
		
		newGolfCourse.setId(oldGolfCourse.getId());
				
		for(Iterator iter = oldGolfCourse.getArchitect(); iter.hasNext();)
		{
			newGolfCourse.addArchitect((String)iter.next());
		}
		return newGolfCourse;
	}
}
