

package golfCourse.ontologies.jastor.contacts;

/*
import com.hp.hpl.jena.datatypes.xsd.*;
import com.hp.hpl.jena.datatypes.xsd.impl.*;
*/
import com.hp.hpl.jena.rdf.model.*;
//import com.ibm.adtech.jastor.JastorException;

/**
 * Interface for Contacts ontology class<br>
 * Use the golfCourse.ontologies.jastor.contacts.ContactsFactory to create instances of this interface.
 * <p>(URI: file:///D:/ontologies/domain/Contacts/Contacts#Contacts)</p>
 * <br>
 * RDF Schema Standard Properties <br>
 * 	comment : Contact information. Nbr, technology, designeted use, type, location. It can refer also to emails, im ids, etc. <br>
 * <br>
 * <br>
 */
public interface Contacts extends com.ibm.adtech.jastor.Thing {
	
	/**
	 * The rdf:type for this ontology class
     */
	public static final Resource TYPE = ResourceFactory.createResource("file:///D:/ontologies/domain/Contacts/Contacts#Contacts");
	

	/**
	 * The Jena Property for use 
	 * <p>(URI: file:///D:/ontologies/domain/Contacts/Contacts#use)</p>
	 * <br>
	 * <br>
	 * RDF Schema Standard Properties <br>
	 * 	comment : The purpose of the contact, what can be achieved when contacting with a particular contact <br>
	 * <br>  
	 */
	public static com.hp.hpl.jena.rdf.model.Property useProperty = ResourceFactory.createProperty("file:///D:/ontologies/domain/Contacts/Contacts#use");


	/**
	 * The Jena Property for location 
	 * <p>(URI: file:///D:/ontologies/domain/Contacts/Contacts#location)</p>
	 * <br>
	 * <br>
	 * RDF Schema Standard Properties <br>
	 * 	comment : Reflects the location/purpose of the particular contact (home, office, etc.) <br>
	 * <br>  
	 */
	public static com.hp.hpl.jena.rdf.model.Property locationProperty = ResourceFactory.createProperty("file:///D:/ontologies/domain/Contacts/Contacts#location");


	/**
	 * The Jena Property for technology 
	 * <p>(URI: file:///D:/ontologies/domain/Contacts/Contacts#technology)</p>
	 * <br>
	 * <br>
	 * RDF Schema Standard Properties <br>
	 * 	comment : Describes the type of the contact, whether it is a telephone, fax, email or SIP address. <br>
	 * <br>  
	 */
	public static com.hp.hpl.jena.rdf.model.Property technologyProperty = ResourceFactory.createProperty("file:///D:/ontologies/domain/Contacts/Contacts#technology");


	/**
	 * The Jena Property for serviceType 
	 * <p>(URI: file:///D:/ontologies/domain/Contacts/Contacts#serviceType)</p>
	 * <br>
	 * <br>
	 * RDF Schema Standard Properties <br>
	 * 	comment : Hotel service type which can be reached with this contact. <br>
	 * <br>  
	 */
	public static com.hp.hpl.jena.rdf.model.Property serviceTypeProperty = ResourceFactory.createProperty("file:///D:/ontologies/domain/Contacts/Contacts#serviceType");


	/**
	 * The Jena Property for address 
	 * <p>(URI: file:///D:/ontologies/domain/Contacts/Contacts#address)</p>
	 * <br>
	 * <br>
	 * RDF Schema Standard Properties <br>
	 * 	comment : Can be a phone/fax number, email, sip, jabber id, multicast... <br>
	 * <br>  
	 */
	public static com.hp.hpl.jena.rdf.model.Property addressProperty = ResourceFactory.createProperty("file:///D:/ontologies/domain/Contacts/Contacts#address");



	/**
	 * Gets the 'use' property value
	 * @return		{@link golfCourse.ontologies.jastor.contacts.UseType}
	 * @see			#useProperty
	 */
	public golfCourse.ontologies.jastor.contacts.UseType getUse() throws com.ibm.adtech.jastor.JastorException;

	/**
	 * Sets the 'use' property value
	 * @param		{@link golfCourse.ontologies.jastor.contacts.UseType}
	 * @see			#useProperty
	 */
	public void setUse(golfCourse.ontologies.jastor.contacts.UseType use) throws com.ibm.adtech.jastor.JastorException;
	
	/**
	 * Sets the 'use' property value to an anonymous node
	 * @return		{@link golfCourse.ontologies.jastor.contacts.UseType}, the created value
	 * @see			#useProperty
	 */	
	public golfCourse.ontologies.jastor.contacts.UseType setUse() throws com.ibm.adtech.jastor.JastorException;
	
	/**
	 * Sets the 'use' property value to the given resource, and add's rdf:type properties.  This
	 * method is equivalent constructing a new instance of {@link golfCourse.ontologies.jastor.contacts.UseType} with the factory.
	 * and calling setUse(golfCourse.ontologies.jastor.contacts.UseType use)
	 * The resource argument have rdf:type file:///D:/ontologies/domain/Contacts/Contacts#UseType.  That is, this method
	 * should not be used as a shortcut for creating new objects in the model.
	 * @param		{@link com.hp.hpl.jena.rdf.model.Resource} must not be be null.
	 * @return		{@link golfCourse.ontologies.jastor.contacts.UseType}, the newly created value
	 * @see			#useProperty
	 */
	public golfCourse.ontologies.jastor.contacts.UseType setUse(com.hp.hpl.jena.rdf.model.Resource resource) throws com.ibm.adtech.jastor.JastorException;
	
	/**
	 * Gets the 'location' property value
	 * @return		{@link golfCourse.ontologies.jastor.contacts.LocationType}
	 * @see			#locationProperty
	 */
	public golfCourse.ontologies.jastor.contacts.LocationType getLocation() throws com.ibm.adtech.jastor.JastorException;

	/**
	 * Sets the 'location' property value
	 * @param		{@link golfCourse.ontologies.jastor.contacts.LocationType}
	 * @see			#locationProperty
	 */
	public void setLocation(golfCourse.ontologies.jastor.contacts.LocationType location) throws com.ibm.adtech.jastor.JastorException;
	
	/**
	 * Sets the 'location' property value to an anonymous node
	 * @return		{@link golfCourse.ontologies.jastor.contacts.LocationType}, the created value
	 * @see			#locationProperty
	 */	
	public golfCourse.ontologies.jastor.contacts.LocationType setLocation() throws com.ibm.adtech.jastor.JastorException;
	
	/**
	 * Sets the 'location' property value to the given resource, and add's rdf:type properties.  This
	 * method is equivalent constructing a new instance of {@link golfCourse.ontologies.jastor.contacts.LocationType} with the factory.
	 * and calling setLocation(golfCourse.ontologies.jastor.contacts.LocationType location)
	 * The resource argument have rdf:type file:///D:/ontologies/domain/Contacts/Contacts#LocationType.  That is, this method
	 * should not be used as a shortcut for creating new objects in the model.
	 * @param		{@link com.hp.hpl.jena.rdf.model.Resource} must not be be null.
	 * @return		{@link golfCourse.ontologies.jastor.contacts.LocationType}, the newly created value
	 * @see			#locationProperty
	 */
	public golfCourse.ontologies.jastor.contacts.LocationType setLocation(com.hp.hpl.jena.rdf.model.Resource resource) throws com.ibm.adtech.jastor.JastorException;
	
	/**
	 * Gets the 'technology' property value
	 * @return		{@link golfCourse.ontologies.jastor.contacts.ContactTechnology}
	 * @see			#technologyProperty
	 */
	public golfCourse.ontologies.jastor.contacts.ContactTechnology getTechnology() throws com.ibm.adtech.jastor.JastorException;

	/**
	 * Sets the 'technology' property value
	 * @param		{@link golfCourse.ontologies.jastor.contacts.ContactTechnology}
	 * @see			#technologyProperty
	 */
	public void setTechnology(golfCourse.ontologies.jastor.contacts.ContactTechnology technology) throws com.ibm.adtech.jastor.JastorException;
	
	/**
	 * Sets the 'technology' property value to an anonymous node
	 * @return		{@link golfCourse.ontologies.jastor.contacts.ContactTechnology}, the created value
	 * @see			#technologyProperty
	 */	
	public golfCourse.ontologies.jastor.contacts.ContactTechnology setTechnology() throws com.ibm.adtech.jastor.JastorException;
	
	/**
	 * Sets the 'technology' property value to the given resource, and add's rdf:type properties.  This
	 * method is equivalent constructing a new instance of {@link golfCourse.ontologies.jastor.contacts.ContactTechnology} with the factory.
	 * and calling setTechnology(golfCourse.ontologies.jastor.contacts.ContactTechnology technology)
	 * The resource argument have rdf:type file:///D:/ontologies/domain/Contacts/Contacts#ContactTechnology.  That is, this method
	 * should not be used as a shortcut for creating new objects in the model.
	 * @param		{@link com.hp.hpl.jena.rdf.model.Resource} must not be be null.
	 * @return		{@link golfCourse.ontologies.jastor.contacts.ContactTechnology}, the newly created value
	 * @see			#technologyProperty
	 */
	public golfCourse.ontologies.jastor.contacts.ContactTechnology setTechnology(com.hp.hpl.jena.rdf.model.Resource resource) throws com.ibm.adtech.jastor.JastorException;
	
	/**
	 * Gets the 'serviceType' property value
	 * @return		{@link golfCourse.ontologies.jastor.contacts.ContactSrvcCode}
	 * @see			#serviceTypeProperty
	 */
	public golfCourse.ontologies.jastor.contacts.ContactSrvcCode getServiceType() throws com.ibm.adtech.jastor.JastorException;

	/**
	 * Sets the 'serviceType' property value
	 * @param		{@link golfCourse.ontologies.jastor.contacts.ContactSrvcCode}
	 * @see			#serviceTypeProperty
	 */
	public void setServiceType(golfCourse.ontologies.jastor.contacts.ContactSrvcCode serviceType) throws com.ibm.adtech.jastor.JastorException;
	
	/**
	 * Sets the 'serviceType' property value to an anonymous node
	 * @return		{@link golfCourse.ontologies.jastor.contacts.ContactSrvcCode}, the created value
	 * @see			#serviceTypeProperty
	 */	
	public golfCourse.ontologies.jastor.contacts.ContactSrvcCode setServiceType() throws com.ibm.adtech.jastor.JastorException;
	
	/**
	 * Sets the 'serviceType' property value to the given resource, and add's rdf:type properties.  This
	 * method is equivalent constructing a new instance of {@link golfCourse.ontologies.jastor.contacts.ContactSrvcCode} with the factory.
	 * and calling setServiceType(golfCourse.ontologies.jastor.contacts.ContactSrvcCode serviceType)
	 * The resource argument have rdf:type file:///D:/ontologies/domain/Contacts/Contacts#ContactSrvcCode.  That is, this method
	 * should not be used as a shortcut for creating new objects in the model.
	 * @param		{@link com.hp.hpl.jena.rdf.model.Resource} must not be be null.
	 * @return		{@link golfCourse.ontologies.jastor.contacts.ContactSrvcCode}, the newly created value
	 * @see			#serviceTypeProperty
	 */
	public golfCourse.ontologies.jastor.contacts.ContactSrvcCode setServiceType(com.hp.hpl.jena.rdf.model.Resource resource) throws com.ibm.adtech.jastor.JastorException;
	
	/**
	 * Gets the 'address' property value
	 * @return		{@link java.lang.String}
	 * @see			#addressProperty
	 */
	public java.lang.String getAddress() throws com.ibm.adtech.jastor.JastorException;

	/**
	 * Sets the 'address' property value
	 * @param		{@link java.lang.String}
	 * @see			#addressProperty
	 */
	public void setAddress(java.lang.String address) throws com.ibm.adtech.jastor.JastorException;

}