

package golfCourse.ontologies.jastor.contacts;

/*
import com.hp.hpl.jena.datatypes.xsd.*;
import com.hp.hpl.jena.datatypes.xsd.impl.*;
*/
import com.hp.hpl.jena.rdf.model.*;
import com.hp.hpl.jena.rdf.listeners.StatementListener;
import com.hp.hpl.jena.vocabulary.RDF;
import com.ibm.adtech.jastor.*;


/**
 * Implementation of {@link golfCourse.ontologies.jastor.contacts.LocationType}
 * Use the golfCourse.ontologies.jastor.contacts.ContactsFactory to create instances of this class.
 * <p>(URI: file:///D:/ontologies/domain/Contacts/Contacts#LocationType)</p>
 * <br>
 */
public class LocationTypeImpl extends com.ibm.adtech.jastor.ThingImpl implements golfCourse.ontologies.jastor.contacts.LocationType {
	


	LocationTypeImpl(Resource resource, Model model) throws JastorException {
		super(resource, model);
		setupModelListener();
	}     
    	
	static LocationTypeImpl getLocationType(Resource resource, Model model) throws JastorException {
		if (!resource.hasProperty(RDF.type,LocationType.TYPE))
			throw new JastorException("Resource " + resource + " not of type " + LocationType.TYPE);
		return new LocationTypeImpl(resource, model);
	}
	    
	static LocationTypeImpl createLocationType(Resource resource, Model model) throws JastorException {
		LocationTypeImpl impl = new LocationTypeImpl(resource, model);
		
		if (!impl._model.contains(new com.hp.hpl.jena.rdf.model.impl.StatementImpl(impl._resource, RDF.type, LocationType.TYPE)))
			impl._model.add(impl._resource, RDF.type, LocationType.TYPE);
		impl.addSuperTypes();
		impl.addHasValueValues();
		return impl;
	}
	
	void addSuperTypes() {
	}
   
	void addHasValueValues() {
	}
    
    private void setupModelListener() {
    	listeners = new java.util.ArrayList();
    	golfCourse.ontologies.jastor.contacts.ContactsFactory.registerThing(this);
    }

	public java.util.List listStatements() {
		java.util.List list = new java.util.ArrayList();
		StmtIterator it = null;
		it = _model.listStatements(_resource,RDF.type, golfCourse.ontologies.jastor.contacts.LocationType.TYPE);
		while (it.hasNext()) {
			list.add(it.next());
		}
		return list;
	}
	
	public void clearCache() {
	}
 


	private java.util.ArrayList listeners;
	
	public void registerListener(ThingListener listener) {
		if (!(listener instanceof LocationTypeListener))
			throw new IllegalArgumentException("ThingListener must be instance of LocationTypeListener"); 
		if (listeners == null)
			setupModelListener();
		if(!this.listeners.contains(listener)){
			this.listeners.add((LocationTypeListener)listener);
		}
	}
	
	public void unregisterListener(ThingListener listener) {
		if (!(listener instanceof LocationTypeListener))
			throw new IllegalArgumentException("ThingListener must be instance of LocationTypeListener"); 
		if (listeners == null)
			return;
		if (this.listeners.contains(listener)){
			listeners.remove(listener);
		}
	}



	// private class ThingModelChangedListener extends StatementListener {
	
		public void addedStatement(com.hp.hpl.jena.rdf.model.Statement stmt) {
//			if (!stmt.getSubject().equals(_resource))
//				return;
		}
		
		public void removedStatement(com.hp.hpl.jena.rdf.model.Statement stmt) {
//			if (!stmt.getSubject().equals(_resource))
//				return;
		}

	//}
	


}