

package golfCourse.ontologies.jastor.description;

/*
import com.hp.hpl.jena.datatypes.xsd.*;
import com.hp.hpl.jena.datatypes.xsd.impl.*;
*/
import com.hp.hpl.jena.rdf.model.*;
import com.hp.hpl.jena.rdf.listeners.StatementListener;
import com.hp.hpl.jena.vocabulary.RDF;
import com.ibm.adtech.jastor.*;


/**
 * Implementation of {@link golfCourse.ontologies.jastor.description.Description}
 * Use the golfCourse.ontologies.jastor.description.DescriptionFactory to create instances of this class.
 * <p>(URI: file:///D:/ontologies/domain/Golf/Description#Description)</p>
 * <br>
 */
public class DescriptionImpl extends com.ibm.adtech.jastor.ThingImpl implements golfCourse.ontologies.jastor.description.Description {
	

	private static com.hp.hpl.jena.rdf.model.Property createDateTimeProperty = ResourceFactory.createProperty("file:///D:/ontologies/domain/Golf/Description#createDateTime");
	private java.lang.String createDateTime;
	private static com.hp.hpl.jena.rdf.model.Property nameProperty = ResourceFactory.createProperty("file:///D:/ontologies/domain/Golf/Description#name");
	private java.lang.String name;

	DescriptionImpl(Resource resource, Model model) throws JastorException {
		super(resource, model);
		setupModelListener();
	}     
    	
	static DescriptionImpl getDescription(Resource resource, Model model) throws JastorException {
		if (!resource.hasProperty(RDF.type,Description.TYPE))
			throw new JastorException("Resource " + resource + " not of type " + Description.TYPE);
		return new DescriptionImpl(resource, model);
	}
	    
	static DescriptionImpl createDescription(Resource resource, Model model) throws JastorException {
		DescriptionImpl impl = new DescriptionImpl(resource, model);
		
		if (!impl._model.contains(new com.hp.hpl.jena.rdf.model.impl.StatementImpl(impl._resource, RDF.type, Description.TYPE)))
			impl._model.add(impl._resource, RDF.type, Description.TYPE);
		impl.addSuperTypes();
		impl.addHasValueValues();
		return impl;
	}
	
	void addSuperTypes() {
	}
   
	void addHasValueValues() {
	}
    
    private void setupModelListener() {
    	listeners = new java.util.ArrayList();
    	golfCourse.ontologies.jastor.description.DescriptionFactory.registerThing(this);
    }

	public java.util.List listStatements() {
		java.util.List list = new java.util.ArrayList();
		StmtIterator it = null;
		it = _resource.listProperties(createDateTimeProperty);
		while (it.hasNext()) {
			list.add(it.next());
		}
		it = _resource.listProperties(nameProperty);
		while (it.hasNext()) {
			list.add(it.next());
		}
		it = _model.listStatements(_resource,RDF.type, golfCourse.ontologies.jastor.description.Description.TYPE);
		while (it.hasNext()) {
			list.add(it.next());
		}
		return list;
	}
	
	public void clearCache() {
		createDateTime = null;
		name = null;
	}

	public java.lang.String getCreateDateTime() throws JastorException {
		if (createDateTime != null)
			return createDateTime;
		com.hp.hpl.jena.rdf.model.Statement stmt = _model.getProperty(_resource, createDateTimeProperty);
		if (stmt == null)
			return null;
		if (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Literal.class))
			throw new JastorInvalidRDFNodeException(uri() + ": createDateTime getProperty() in golfCourse.ontologies.jastor.description.Description model not Literal", stmt.getObject());
		com.hp.hpl.jena.rdf.model.Literal literal = (com.hp.hpl.jena.rdf.model.Literal) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Literal.class);
		Object obj = literal.getValue();
		if (!(obj instanceof java.lang.String))
			throw new JastorInvalidLiteralException (this.uri() + ": Literal createDateTime in Description is not of type java.lang.String", literal);
		createDateTime = (java.lang.String)obj;
		return createDateTime;
	}
	
	public void setCreateDateTime(java.lang.String createDateTime) throws JastorException {
		if (_resource.hasProperty(createDateTimeProperty)) {
			_resource.removeAll(createDateTimeProperty);
		}
		this.createDateTime = createDateTime;                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   
		if (createDateTime != null) {
			_resource.addProperty(createDateTimeProperty, _model.createTypedLiteral(createDateTime));
		}	
	}

	public java.lang.String getName() throws JastorException {
		if (name != null)
			return name;
		com.hp.hpl.jena.rdf.model.Statement stmt = _model.getProperty(_resource, nameProperty);
		if (stmt == null)
			return null;
		if (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Literal.class))
			throw new JastorInvalidRDFNodeException(uri() + ": name getProperty() in golfCourse.ontologies.jastor.description.Description model not Literal", stmt.getObject());
		com.hp.hpl.jena.rdf.model.Literal literal = (com.hp.hpl.jena.rdf.model.Literal) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Literal.class);
		Object obj = literal.getValue();
		if (!(obj instanceof java.lang.String))
			throw new JastorInvalidLiteralException (this.uri() + ": Literal name in Description is not of type java.lang.String", literal);
		name = (java.lang.String)obj;
		return name;
	}
	
	public void setName(java.lang.String name) throws JastorException {
		if (_resource.hasProperty(nameProperty)) {
			_resource.removeAll(nameProperty);
		}
		this.name = name;                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   
		if (name != null) {
			_resource.addProperty(nameProperty, _model.createTypedLiteral(name));
		}	
	}
 


	private java.util.ArrayList listeners;
	
	public void registerListener(ThingListener listener) {
		if (!(listener instanceof DescriptionListener))
			throw new IllegalArgumentException("ThingListener must be instance of DescriptionListener"); 
		if (listeners == null)
			setupModelListener();
		if(!this.listeners.contains(listener)){
			this.listeners.add((DescriptionListener)listener);
		}
	}
	
	public void unregisterListener(ThingListener listener) {
		if (!(listener instanceof DescriptionListener))
			throw new IllegalArgumentException("ThingListener must be instance of DescriptionListener"); 
		if (listeners == null)
			return;
		if (this.listeners.contains(listener)){
			listeners.remove(listener);
		}
	}



	// private class ThingModelChangedListener extends StatementListener {
	
		public void addedStatement(com.hp.hpl.jena.rdf.model.Statement stmt) {
//			if (!stmt.getSubject().equals(_resource))
//				return;
			if (stmt.getPredicate().equals(createDateTimeProperty)) {
				if (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Literal.class))
					return;
				com.hp.hpl.jena.rdf.model.Literal literal = (com.hp.hpl.jena.rdf.model.Literal) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Literal.class);
				//Object obj = literal.getValue();
				Object obj = literal.getValue();
				if (obj instanceof java.lang.String)
					createDateTime = (java.lang.String) obj;
				if (listeners != null) {
					java.util.ArrayList consumers;
					synchronized (listeners) {
						consumers = (java.util.ArrayList) listeners.clone();
					}
					for(java.util.Iterator iter=consumers.iterator();iter.hasNext();){
						DescriptionListener listener=(DescriptionListener)iter.next();
						listener.createDateTimeChanged(golfCourse.ontologies.jastor.description.DescriptionImpl.this);
					}
				}
				return;
			}
			if (stmt.getPredicate().equals(nameProperty)) {
				if (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Literal.class))
					return;
				com.hp.hpl.jena.rdf.model.Literal literal = (com.hp.hpl.jena.rdf.model.Literal) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Literal.class);
				//Object obj = literal.getValue();
				Object obj = literal.getValue();
				if (obj instanceof java.lang.String)
					name = (java.lang.String) obj;
				if (listeners != null) {
					java.util.ArrayList consumers;
					synchronized (listeners) {
						consumers = (java.util.ArrayList) listeners.clone();
					}
					for(java.util.Iterator iter=consumers.iterator();iter.hasNext();){
						DescriptionListener listener=(DescriptionListener)iter.next();
						listener.nameChanged(golfCourse.ontologies.jastor.description.DescriptionImpl.this);
					}
				}
				return;
			}
		}
		
		public void removedStatement(com.hp.hpl.jena.rdf.model.Statement stmt) {
//			if (!stmt.getSubject().equals(_resource))
//				return;
			if (stmt.getPredicate().equals(createDateTimeProperty)) {
				if (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Literal.class))
					return;
				com.hp.hpl.jena.rdf.model.Literal literal = (com.hp.hpl.jena.rdf.model.Literal) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Literal.class);
				//Object obj = literal.getValue();
				Object obj = literal.getValue(); // UPDATED
				if (obj instanceof java.lang.String)
					if (createDateTime != null && createDateTime.equals(obj))
						createDateTime = null;
				if (listeners != null) {
					java.util.ArrayList consumers;
					synchronized (listeners) {
						consumers = (java.util.ArrayList) listeners.clone();
					}
					for(java.util.Iterator iter=consumers.iterator();iter.hasNext();){
						DescriptionListener listener=(DescriptionListener)iter.next();
						listener.createDateTimeChanged(golfCourse.ontologies.jastor.description.DescriptionImpl.this);
					}
				}
				return;
			}
			if (stmt.getPredicate().equals(nameProperty)) {
				if (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Literal.class))
					return;
				com.hp.hpl.jena.rdf.model.Literal literal = (com.hp.hpl.jena.rdf.model.Literal) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Literal.class);
				//Object obj = literal.getValue();
				Object obj = literal.getValue(); // UPDATED
				if (obj instanceof java.lang.String)
					if (name != null && name.equals(obj))
						name = null;
				if (listeners != null) {
					java.util.ArrayList consumers;
					synchronized (listeners) {
						consumers = (java.util.ArrayList) listeners.clone();
					}
					for(java.util.Iterator iter=consumers.iterator();iter.hasNext();){
						DescriptionListener listener=(DescriptionListener)iter.next();
						listener.nameChanged(golfCourse.ontologies.jastor.description.DescriptionImpl.this);
					}
				}
				return;
			}
		}

	//}
	


}