

package golfCourse.ontologies.jastor.fee;

/*
import com.hp.hpl.jena.datatypes.xsd.*;
import com.hp.hpl.jena.datatypes.xsd.impl.*;
*/
import com.hp.hpl.jena.rdf.model.*;
//import com.ibm.adtech.jastor.JastorException;

/**
 * Interface for Fee ontology class<br>
 * Use the golfCourse.ontologies.jastor.fee.FeeFactory to create instances of this interface.
 * <p>(URI: file:///D:/ontologies/domain/Golf/Fee#Fee)</p>
 * <br>
 * <br>
 * <br>
 */
public interface Fee extends com.ibm.adtech.jastor.Thing {
	
	/**
	 * The rdf:type for this ontology class
     */
	public static final Resource TYPE = ResourceFactory.createResource("file:///D:/ontologies/domain/Golf/Fee#Fee");
	

	/**
	 * The Jena Property for effectiveDate 
	 * <p>(URI: file:///D:/ontologies/domain/Golf/Fee#effectiveDate)</p>
	 * <br>  
	 */
	public static com.hp.hpl.jena.rdf.model.Property effectiveDateProperty = ResourceFactory.createProperty("file:///D:/ontologies/domain/Golf/Fee#effectiveDate");


	/**
	 * The Jena Property for expireDate 
	 * <p>(URI: file:///D:/ontologies/domain/Golf/Fee#expireDate)</p>
	 * <br>  
	 */
	public static com.hp.hpl.jena.rdf.model.Property expireDateProperty = ResourceFactory.createProperty("file:///D:/ontologies/domain/Golf/Fee#expireDate");


	/**
	 * The Jena Property for price 
	 * <p>(URI: file:///D:/ontologies/domain/Golf/Fee#price)</p>
	 * <br>  
	 */
	public static com.hp.hpl.jena.rdf.model.Property priceProperty = ResourceFactory.createProperty("file:///D:/ontologies/domain/Golf/Fee#price");


	/**
	 * The Jena Property for description 
	 * <p>(URI: file:///D:/ontologies/domain/Golf/Fee#description)</p>
	 * <br>  
	 */
	public static com.hp.hpl.jena.rdf.model.Property descriptionProperty = ResourceFactory.createProperty("file:///D:/ontologies/domain/Golf/Fee#description");



	/**
	 * Gets the 'effectiveDate' property value
	 * @return		{@link java.lang.String}
	 * @see			#effectiveDateProperty
	 */
	public java.lang.String getEffectiveDate() throws com.ibm.adtech.jastor.JastorException;

	/**
	 * Sets the 'effectiveDate' property value
	 * @param		{@link java.lang.String}
	 * @see			#effectiveDateProperty
	 */
	public void setEffectiveDate(java.lang.String effectiveDate) throws com.ibm.adtech.jastor.JastorException;

	/**
	 * Gets the 'expireDate' property value
	 * @return		{@link java.lang.String}
	 * @see			#expireDateProperty
	 */
	public java.lang.String getExpireDate() throws com.ibm.adtech.jastor.JastorException;

	/**
	 * Sets the 'expireDate' property value
	 * @param		{@link java.lang.String}
	 * @see			#expireDateProperty
	 */
	public void setExpireDate(java.lang.String expireDate) throws com.ibm.adtech.jastor.JastorException;

	/**
	 * Gets the 'price' property value
	 * @return		{@link com.ibm.adtech.jastor.Thing}
	 * @see			#priceProperty
	 */
	public com.ibm.adtech.jastor.Thing getPrice() throws com.ibm.adtech.jastor.JastorException;

	/**
	 * Sets the 'price' property value
	 * @param		{@link com.ibm.adtech.jastor.Thing}
	 * @see			#priceProperty
	 */
	public void setPrice(com.ibm.adtech.jastor.Thing price) throws com.ibm.adtech.jastor.JastorException;
	
	/**
	 * Sets the 'price' property value to an anonymous node
	 * @return		{@link com.ibm.adtech.jastor.Thing}, the created value
	 * @see			#priceProperty
	 */	
	public com.ibm.adtech.jastor.Thing setPrice() throws com.ibm.adtech.jastor.JastorException;
	
	/**
	 * Sets the 'price' property value to the given resource, and add's rdf:type properties.  This
	 * method is equivalent constructing a new instance of {@link com.ibm.adtech.jastor.Thing} with the factory.
	 * and calling setPrice(com.ibm.adtech.jastor.Thing price)
	 * The resource argument have rdf:type http://www.w3.org/2000/01/rdf-schema#Resource.  That is, this method
	 * should not be used as a shortcut for creating new objects in the model.
	 * @param		{@link com.hp.hpl.jena.rdf.model.Resource} must not be be null.
	 * @return		{@link com.ibm.adtech.jastor.Thing}, the newly created value
	 * @see			#priceProperty
	 */
	public com.ibm.adtech.jastor.Thing setPrice(com.hp.hpl.jena.rdf.model.Resource resource) throws com.ibm.adtech.jastor.JastorException;
	
	/**
	 * Get an Iterator the 'description' property values.  This Iteartor
	 * may be used to remove all such values.
	 * @return		{@link java.util.Iterator} of {@link com.ibm.adtech.jastor.Thing}
	 * @see			#descriptionProperty
	 */
	public java.util.Iterator getDescription() throws com.ibm.adtech.jastor.JastorException;

	/**
	 * Adds a value for the 'description' property
	 * @param		The {@link com.ibm.adtech.jastor.Thing} to add
	 * @see			#descriptionProperty
	 */
	public void addDescription(com.ibm.adtech.jastor.Thing description) throws com.ibm.adtech.jastor.JastorException;
	
	/**
	 * Adds an anonymous value for the 'description' property
	 * @return		The anoymous {@link com.ibm.adtech.jastor.Thing} created
	 * @see			#descriptionProperty
	 */
	public com.ibm.adtech.jastor.Thing addDescription() throws com.ibm.adtech.jastor.JastorException;
	
	/**
	 * Adds a value for the 'description' property.  This
	 * method is equivalent constructing a new instance of {@link com.ibm.adtech.jastor.Thing} with the factory
	 * and calling addDescription(com.ibm.adtech.jastor.Thing description)
	 * The resource argument have rdf:type http://www.w3.org/2000/01/rdf-schema#Resource.  That is, this method
	 * should not be used as a shortcut for creating new objects in the model.
	 * @param		The {@link om.hp.hpl.jena.rdf.model.Resource} to add
	 * @see			#descriptionProperty
	 */
	public com.ibm.adtech.jastor.Thing addDescription(com.hp.hpl.jena.rdf.model.Resource resource) throws com.ibm.adtech.jastor.JastorException;
	
	/**
	 * Removes a value for the 'description' property.  This method should not
	 * be invoked while iterator through values.  In that case, the remove() method of the Iterator
	 * itself should be used.
	 * @param		The {@link com.ibm.adtech.jastor.Thing} to remove
	 * @see			#descriptionProperty
	 */
	public void removeDescription(com.ibm.adtech.jastor.Thing description) throws com.ibm.adtech.jastor.JastorException;
		
}