package golfCourse.ontology.storage;

import golfCourse.properties.GolfCourseSystemProperties;

import com.hp.hpl.jena.ontology.OntModel;

public class DomainModelsFactory {

	private static OntModel golfCourseModel = null;
	private static OntModel contactsModel = null;
	private static OntModel addressRecord = null;
	private static OntModel golfCourseTeeTime = null;
	private static OntModel feeModel = null;
	private static OntModel priceModel = null;
	private static OntModel descriptionModel = null;
	
	public DomainModelsFactory()
	{	}
	
	public static OntModel getGolfCourseTeeTimeModel()
	{
		if (golfCourseTeeTime == null)
			golfCourseTeeTime = ModelLoader.loadModel(GolfCourseSystemProperties.DOMAIN_GOLF_COURSE_TEE_TIME);
		return golfCourseTeeTime;
	}
	
	public static OntModel getFeeModel()
	{
		return ModelLoader.loadModel(GolfCourseSystemProperties.DOMAIN_FEE);
	}
	
	public static OntModel getPriceModel()
	{
		return ModelLoader.loadModel(GolfCourseSystemProperties.DOMAIN_PRICE);
	}
	
	public static OntModel getDescriptionModel()
	{
		return ModelLoader.loadModel(GolfCourseSystemProperties.DOMAIN_DESCRIPTION);
	}
	
	public static OntModel getGolfCourseDomain()
	{
		if(golfCourseModel != null)
			return golfCourseModel;
		return ModelLoader.loadModel(GolfCourseSystemProperties.DOMAIN_GOLF_COURSE);
	}
	
	public static OntModel getContactsDomain()
	{
		if(contactsModel != null)
			return contactsModel;
		return ModelLoader.loadModel(GolfCourseSystemProperties.DOMAIN_CONTACTS);
	}
	
	public static OntModel getAddressDomain()
	{
		if(addressRecord != null)
			return addressRecord;
		return ModelLoader.loadModel(GolfCourseSystemProperties.DOMAIN_ADDRESS_RECORD);
	}
}
