/*
 * This class was automatically generated with 
 * <a href="http://www.castor.org">Castor 0.9.5.2</a>, using an XML
 * Schema.
 * $Id$
 */

package golfCourse.translations.castor;

  //---------------------------------/
 //- Imported classes and packages -/
//---------------------------------/

import golfCourse.translations.castor.types.RatePeriodSimpleType;
import java.io.IOException;
import java.io.Reader;
import java.io.Serializable;
import java.io.Writer;
import java.util.Enumeration;
import java.util.Vector;
import org.exolab.castor.xml.MarshalException;
import org.exolab.castor.xml.Marshaller;
import org.exolab.castor.xml.Unmarshaller;
import org.exolab.castor.xml.ValidationException;
import org.xml.sax.ContentHandler;

/**
 * The RateQualifierType complex type describes fully rate
 * information associated with a specific rate quotation, including
 * the description of any promotions that may apply.
 * 
 * @version $Revision$ $Date$
 */
public class RateQualifierType implements java.io.Serializable {


      //--------------------------/
     //- Class/Member Variables -/
    //--------------------------/

    /**
     * Indicates if this rate is only available to those customers
     * who are flying to the vehicle rental location.
     */
    private boolean _arriveByFlight = false;

    /**
     * keeps track of state for field: _arriveByFlight
     */
    private boolean _has_arriveByFlight;

    /**
     * The rate authorization code for this rate.
     */
    private java.lang.String _rateAuthorizationCode;

    /**
     * The identifier assigned to this rate by the vendor.
     */
    private java.lang.String _vendorRateID;

    /**
     * Used to indicate the purpose, whether for business, personal
     * or other. Refer to OTA Code List Travel Purpose (TVP).
     */
    private java.lang.String _travelPurpose;

    /**
     * The RateCategory attribute defines a set of valid values for
     * the category of a rate. Typically rates are offered as
     * either Leisure rates or Business (Corporate) rates, with a
     * business rate usually including additional costs such as the
     * cost of insurance, etc. This set of values defines the rate
     * categories. Refer to OTA Code List Rate Category(RTC).
     */
    private java.lang.String _rateCategory;

    /**
     * This is the vendor specific code used to identify a special
     * rate associated with a specific organization.
     */
    private java.lang.String _corpDiscountNmbr;

    /**
     * This is the vendor specific code for rate codes (e.g. WES,
     * 2A, DLY00).
     */
    private java.lang.String _rateQualifier;

    /**
     * The RatePeriod attribute defines the type of rate that may
     * be applied. For example, typically car rental rates differ
     * based upon the duration of the rental, and the actual rate
     * is then expressed in terms of the period of the rental.
     */
    private golfCourse.translations.castor.types.RatePeriodSimpleType _ratePeriod;

    /**
     * When true, only guaranteed rates should be returned. When
     * false, all rates should be returned
     */
    private boolean _guaranteedInd;

    /**
     * keeps track of state for field: _guaranteedInd
     */
    private boolean _has_guaranteedInd;

    /**
     * Promotion code is the identifier used by the host to link
     * directly with a specific named advertising campaign. By
     * including the required code, the client is able to gain
     * access to special offers which may have been created for a
     * specifically targeted group via a CRM system or for a wider
     * advertising campaign using Television or press adverts.
     */
    private java.lang.String _promotionCode;

    /**
     * List of the vendor codes associated with a promotion.
     */
    private java.util.Vector _promotionVendorCodeList;

    /**
     * This may be used to provide additional information about the
     * promotion code.
     */
    private java.lang.String _promoDesc;

    /**
     * Field _rateComments
     */
    private golfCourse.translations.castor.RateComments _rateComments;


      //----------------/
     //- Constructors -/
    //----------------/

    public RateQualifierType() {
        super();
        _promotionVendorCodeList = new Vector();
    } //-- golfCourse.translations.castor.RateQualifierType()


      //-----------/
     //- Methods -/
    //-----------/

    /**
     * Method addPromotionVendorCode
     * 
     * @param vPromotionVendorCode
     */
    public void addPromotionVendorCode(java.lang.String vPromotionVendorCode)
        throws java.lang.IndexOutOfBoundsException
    {
        _promotionVendorCodeList.addElement(vPromotionVendorCode);
    } //-- void addPromotionVendorCode(java.lang.String) 

    /**
     * Method addPromotionVendorCode
     * 
     * @param index
     * @param vPromotionVendorCode
     */
    public void addPromotionVendorCode(int index, java.lang.String vPromotionVendorCode)
        throws java.lang.IndexOutOfBoundsException
    {
        _promotionVendorCodeList.insertElementAt(vPromotionVendorCode, index);
    } //-- void addPromotionVendorCode(int, java.lang.String) 

    /**
     * Method deleteArriveByFlight
     */
    public void deleteArriveByFlight()
    {
        this._has_arriveByFlight= false;
    } //-- void deleteArriveByFlight() 

    /**
     * Method deleteGuaranteedInd
     */
    public void deleteGuaranteedInd()
    {
        this._has_guaranteedInd= false;
    } //-- void deleteGuaranteedInd() 

    /**
     * Method enumeratePromotionVendorCode
     */
    public java.util.Enumeration enumeratePromotionVendorCode()
    {
        return _promotionVendorCodeList.elements();
    } //-- java.util.Enumeration enumeratePromotionVendorCode() 

    /**
     * Returns the value of field 'arriveByFlight'. The field
     * 'arriveByFlight' has the following description: Indicates if
     * this rate is only available to those customers who are
     * flying to the vehicle rental location.
     * 
     * @return the value of field 'arriveByFlight'.
     */
    public boolean getArriveByFlight()
    {
        return this._arriveByFlight;
    } //-- boolean getArriveByFlight() 

    /**
     * Returns the value of field 'corpDiscountNmbr'. The field
     * 'corpDiscountNmbr' has the following description: This is
     * the vendor specific code used to identify a special rate
     * associated with a specific organization.
     * 
     * @return the value of field 'corpDiscountNmbr'.
     */
    public java.lang.String getCorpDiscountNmbr()
    {
        return this._corpDiscountNmbr;
    } //-- java.lang.String getCorpDiscountNmbr() 

    /**
     * Returns the value of field 'guaranteedInd'. The field
     * 'guaranteedInd' has the following description: When true,
     * only guaranteed rates should be returned. When false, all
     * rates should be returned
     * 
     * @return the value of field 'guaranteedInd'.
     */
    public boolean getGuaranteedInd()
    {
        return this._guaranteedInd;
    } //-- boolean getGuaranteedInd() 

    /**
     * Returns the value of field 'promoDesc'. The field
     * 'promoDesc' has the following description: This may be used
     * to provide additional information about the promotion code.
     * 
     * @return the value of field 'promoDesc'.
     */
    public java.lang.String getPromoDesc()
    {
        return this._promoDesc;
    } //-- java.lang.String getPromoDesc() 

    /**
     * Returns the value of field 'promotionCode'. The field
     * 'promotionCode' has the following description: Promotion
     * code is the identifier used by the host to link directly
     * with a specific named advertising campaign. By including the
     * required code, the client is able to gain access to special
     * offers which may have been created for a specifically
     * targeted group via a CRM system or for a wider advertising
     * campaign using Television or press adverts.
     * 
     * @return the value of field 'promotionCode'.
     */
    public java.lang.String getPromotionCode()
    {
        return this._promotionCode;
    } //-- java.lang.String getPromotionCode() 

    /**
     * Method getPromotionVendorCode
     * 
     * @param index
     */
    public java.lang.String getPromotionVendorCode(int index)
        throws java.lang.IndexOutOfBoundsException
    {
        //-- check bounds for index
        if ((index < 0) || (index > _promotionVendorCodeList.size())) {
            throw new IndexOutOfBoundsException();
        }
        
        return (String)_promotionVendorCodeList.elementAt(index);
    } //-- java.lang.String getPromotionVendorCode(int) 

    /**
     * Method getPromotionVendorCode
     */
    public java.lang.String[] getPromotionVendorCode()
    {
        int size = _promotionVendorCodeList.size();
        java.lang.String[] mArray = new java.lang.String[size];
        for (int index = 0; index < size; index++) {
            mArray[index] = (String)_promotionVendorCodeList.elementAt(index);
        }
        return mArray;
    } //-- java.lang.String[] getPromotionVendorCode() 

    /**
     * Method getPromotionVendorCodeCount
     */
    public int getPromotionVendorCodeCount()
    {
        return _promotionVendorCodeList.size();
    } //-- int getPromotionVendorCodeCount() 

    /**
     * Returns the value of field 'rateAuthorizationCode'. The
     * field 'rateAuthorizationCode' has the following description:
     * The rate authorization code for this rate.
     * 
     * @return the value of field 'rateAuthorizationCode'.
     */
    public java.lang.String getRateAuthorizationCode()
    {
        return this._rateAuthorizationCode;
    } //-- java.lang.String getRateAuthorizationCode() 

    /**
     * Returns the value of field 'rateCategory'. The field
     * 'rateCategory' has the following description: The
     * RateCategory attribute defines a set of valid values for the
     * category of a rate. Typically rates are offered as either
     * Leisure rates or Business (Corporate) rates, with a business
     * rate usually including additional costs such as the cost of
     * insurance, etc. This set of values defines the rate
     * categories. Refer to OTA Code List Rate Category(RTC).
     * 
     * @return the value of field 'rateCategory'.
     */
    public java.lang.String getRateCategory()
    {
        return this._rateCategory;
    } //-- java.lang.String getRateCategory() 

    /**
     * Returns the value of field 'rateComments'.
     * 
     * @return the value of field 'rateComments'.
     */
    public golfCourse.translations.castor.RateComments getRateComments()
    {
        return this._rateComments;
    } //-- golfCourse.translations.castor.RateComments getRateComments() 

    /**
     * Returns the value of field 'ratePeriod'. The field
     * 'ratePeriod' has the following description: The RatePeriod
     * attribute defines the type of rate that may be applied. For
     * example, typically car rental rates differ based upon the
     * duration of the rental, and the actual rate is then
     * expressed in terms of the period of the rental.
     * 
     * @return the value of field 'ratePeriod'.
     */
    public golfCourse.translations.castor.types.RatePeriodSimpleType getRatePeriod()
    {
        return this._ratePeriod;
    } //-- golfCourse.translations.castor.types.RatePeriodSimpleType getRatePeriod() 

    /**
     * Returns the value of field 'rateQualifier'. The field
     * 'rateQualifier' has the following description: This is the
     * vendor specific code for rate codes (e.g. WES, 2A, DLY00).
     * 
     * @return the value of field 'rateQualifier'.
     */
    public java.lang.String getRateQualifier()
    {
        return this._rateQualifier;
    } //-- java.lang.String getRateQualifier() 

    /**
     * Returns the value of field 'travelPurpose'. The field
     * 'travelPurpose' has the following description: Used to
     * indicate the purpose, whether for business, personal or
     * other. Refer to OTA Code List Travel Purpose (TVP).
     * 
     * @return the value of field 'travelPurpose'.
     */
    public java.lang.String getTravelPurpose()
    {
        return this._travelPurpose;
    } //-- java.lang.String getTravelPurpose() 

    /**
     * Returns the value of field 'vendorRateID'. The field
     * 'vendorRateID' has the following description: The identifier
     * assigned to this rate by the vendor.
     * 
     * @return the value of field 'vendorRateID'.
     */
    public java.lang.String getVendorRateID()
    {
        return this._vendorRateID;
    } //-- java.lang.String getVendorRateID() 

    /**
     * Method hasArriveByFlight
     */
    public boolean hasArriveByFlight()
    {
        return this._has_arriveByFlight;
    } //-- boolean hasArriveByFlight() 

    /**
     * Method hasGuaranteedInd
     */
    public boolean hasGuaranteedInd()
    {
        return this._has_guaranteedInd;
    } //-- boolean hasGuaranteedInd() 

    /**
     * Method isValid
     */
    public boolean isValid()
    {
        try {
            validate();
        }
        catch (org.exolab.castor.xml.ValidationException vex) {
            return false;
        }
        return true;
    } //-- boolean isValid() 

    /**
     * Method marshal
     * 
     * @param out
     */
    public void marshal(java.io.Writer out)
        throws org.exolab.castor.xml.MarshalException, org.exolab.castor.xml.ValidationException
    {
        
        Marshaller.marshal(this, out);
    } //-- void marshal(java.io.Writer) 

    /**
     * Method marshal
     * 
     * @param handler
     */
    public void marshal(org.xml.sax.ContentHandler handler)
        throws java.io.IOException, org.exolab.castor.xml.MarshalException, org.exolab.castor.xml.ValidationException
    {
        
        Marshaller.marshal(this, handler);
    } //-- void marshal(org.xml.sax.ContentHandler) 

    /**
     * Method removeAllPromotionVendorCode
     */
    public void removeAllPromotionVendorCode()
    {
        _promotionVendorCodeList.removeAllElements();
    } //-- void removeAllPromotionVendorCode() 

    /**
     * Method removePromotionVendorCode
     * 
     * @param index
     */
    public java.lang.String removePromotionVendorCode(int index)
    {
        java.lang.Object obj = _promotionVendorCodeList.elementAt(index);
        _promotionVendorCodeList.removeElementAt(index);
        return (String)obj;
    } //-- java.lang.String removePromotionVendorCode(int) 

    /**
     * Sets the value of field 'arriveByFlight'. The field
     * 'arriveByFlight' has the following description: Indicates if
     * this rate is only available to those customers who are
     * flying to the vehicle rental location.
     * 
     * @param arriveByFlight the value of field 'arriveByFlight'.
     */
    public void setArriveByFlight(boolean arriveByFlight)
    {
        this._arriveByFlight = arriveByFlight;
        this._has_arriveByFlight = true;
    } //-- void setArriveByFlight(boolean) 

    /**
     * Sets the value of field 'corpDiscountNmbr'. The field
     * 'corpDiscountNmbr' has the following description: This is
     * the vendor specific code used to identify a special rate
     * associated with a specific organization.
     * 
     * @param corpDiscountNmbr the value of field 'corpDiscountNmbr'
     */
    public void setCorpDiscountNmbr(java.lang.String corpDiscountNmbr)
    {
        this._corpDiscountNmbr = corpDiscountNmbr;
    } //-- void setCorpDiscountNmbr(java.lang.String) 

    /**
     * Sets the value of field 'guaranteedInd'. The field
     * 'guaranteedInd' has the following description: When true,
     * only guaranteed rates should be returned. When false, all
     * rates should be returned
     * 
     * @param guaranteedInd the value of field 'guaranteedInd'.
     */
    public void setGuaranteedInd(boolean guaranteedInd)
    {
        this._guaranteedInd = guaranteedInd;
        this._has_guaranteedInd = true;
    } //-- void setGuaranteedInd(boolean) 

    /**
     * Sets the value of field 'promoDesc'. The field 'promoDesc'
     * has the following description: This may be used to provide
     * additional information about the promotion code.
     * 
     * @param promoDesc the value of field 'promoDesc'.
     */
    public void setPromoDesc(java.lang.String promoDesc)
    {
        this._promoDesc = promoDesc;
    } //-- void setPromoDesc(java.lang.String) 

    /**
     * Sets the value of field 'promotionCode'. The field
     * 'promotionCode' has the following description: Promotion
     * code is the identifier used by the host to link directly
     * with a specific named advertising campaign. By including the
     * required code, the client is able to gain access to special
     * offers which may have been created for a specifically
     * targeted group via a CRM system or for a wider advertising
     * campaign using Television or press adverts.
     * 
     * @param promotionCode the value of field 'promotionCode'.
     */
    public void setPromotionCode(java.lang.String promotionCode)
    {
        this._promotionCode = promotionCode;
    } //-- void setPromotionCode(java.lang.String) 

    /**
     * Method setPromotionVendorCode
     * 
     * @param index
     * @param vPromotionVendorCode
     */
    public void setPromotionVendorCode(int index, java.lang.String vPromotionVendorCode)
        throws java.lang.IndexOutOfBoundsException
    {
        //-- check bounds for index
        if ((index < 0) || (index > _promotionVendorCodeList.size())) {
            throw new IndexOutOfBoundsException();
        }
        _promotionVendorCodeList.setElementAt(vPromotionVendorCode, index);
    } //-- void setPromotionVendorCode(int, java.lang.String) 

    /**
     * Method setPromotionVendorCode
     * 
     * @param promotionVendorCodeArray
     */
    public void setPromotionVendorCode(java.lang.String[] promotionVendorCodeArray)
    {
        //-- copy array
        _promotionVendorCodeList.removeAllElements();
        for (int i = 0; i < promotionVendorCodeArray.length; i++) {
            _promotionVendorCodeList.addElement(promotionVendorCodeArray[i]);
        }
    } //-- void setPromotionVendorCode(java.lang.String) 

    /**
     * Sets the value of field 'rateAuthorizationCode'. The field
     * 'rateAuthorizationCode' has the following description: The
     * rate authorization code for this rate.
     * 
     * @param rateAuthorizationCode the value of field
     * 'rateAuthorizationCode'.
     */
    public void setRateAuthorizationCode(java.lang.String rateAuthorizationCode)
    {
        this._rateAuthorizationCode = rateAuthorizationCode;
    } //-- void setRateAuthorizationCode(java.lang.String) 

    /**
     * Sets the value of field 'rateCategory'. The field
     * 'rateCategory' has the following description: The
     * RateCategory attribute defines a set of valid values for the
     * category of a rate. Typically rates are offered as either
     * Leisure rates or Business (Corporate) rates, with a business
     * rate usually including additional costs such as the cost of
     * insurance, etc. This set of values defines the rate
     * categories. Refer to OTA Code List Rate Category(RTC).
     * 
     * @param rateCategory the value of field 'rateCategory'.
     */
    public void setRateCategory(java.lang.String rateCategory)
    {
        this._rateCategory = rateCategory;
    } //-- void setRateCategory(java.lang.String) 

    /**
     * Sets the value of field 'rateComments'.
     * 
     * @param rateComments the value of field 'rateComments'.
     */
    public void setRateComments(golfCourse.translations.castor.RateComments rateComments)
    {
        this._rateComments = rateComments;
    } //-- void setRateComments(golfCourse.translations.castor.RateComments) 

    /**
     * Sets the value of field 'ratePeriod'. The field 'ratePeriod'
     * has the following description: The RatePeriod attribute
     * defines the type of rate that may be applied. For example,
     * typically car rental rates differ based upon the duration of
     * the rental, and the actual rate is then expressed in terms
     * of the period of the rental.
     * 
     * @param ratePeriod the value of field 'ratePeriod'.
     */
    public void setRatePeriod(golfCourse.translations.castor.types.RatePeriodSimpleType ratePeriod)
    {
        this._ratePeriod = ratePeriod;
    } //-- void setRatePeriod(golfCourse.translations.castor.types.RatePeriodSimpleType) 

    /**
     * Sets the value of field 'rateQualifier'. The field
     * 'rateQualifier' has the following description: This is the
     * vendor specific code for rate codes (e.g. WES, 2A, DLY00).
     * 
     * @param rateQualifier the value of field 'rateQualifier'.
     */
    public void setRateQualifier(java.lang.String rateQualifier)
    {
        this._rateQualifier = rateQualifier;
    } //-- void setRateQualifier(java.lang.String) 

    /**
     * Sets the value of field 'travelPurpose'. The field
     * 'travelPurpose' has the following description: Used to
     * indicate the purpose, whether for business, personal or
     * other. Refer to OTA Code List Travel Purpose (TVP).
     * 
     * @param travelPurpose the value of field 'travelPurpose'.
     */
    public void setTravelPurpose(java.lang.String travelPurpose)
    {
        this._travelPurpose = travelPurpose;
    } //-- void setTravelPurpose(java.lang.String) 

    /**
     * Sets the value of field 'vendorRateID'. The field
     * 'vendorRateID' has the following description: The identifier
     * assigned to this rate by the vendor.
     * 
     * @param vendorRateID the value of field 'vendorRateID'.
     */
    public void setVendorRateID(java.lang.String vendorRateID)
    {
        this._vendorRateID = vendorRateID;
    } //-- void setVendorRateID(java.lang.String) 

    /**
     * Method unmarshal
     * 
     * @param reader
     */
    public static java.lang.Object unmarshal(java.io.Reader reader)
        throws org.exolab.castor.xml.MarshalException, org.exolab.castor.xml.ValidationException
    {
        return (golfCourse.translations.castor.RateQualifierType) Unmarshaller.unmarshal(golfCourse.translations.castor.RateQualifierType.class, reader);
    } //-- java.lang.Object unmarshal(java.io.Reader) 

    /**
     * Method validate
     */
    public void validate()
        throws org.exolab.castor.xml.ValidationException
    {
        org.exolab.castor.xml.Validator validator = new org.exolab.castor.xml.Validator();
        validator.validate(this);
    } //-- void validate() 

}
