/*
 * This class was automatically generated with 
 * <a href="http://www.castor.org">Castor 0.9.5.2</a>, using an XML
 * Schema.
 * $Id$
 */

package golfCourse.translations.castor;

  //---------------------------------/
 //- Imported classes and packages -/
//---------------------------------/

import golfCourse.translations.castor.types.AmountDeterminationType;
import java.io.IOException;
import java.io.Reader;
import java.io.Serializable;
import java.io.Writer;
import java.math.BigDecimal;
import java.util.Enumeration;
import java.util.Vector;
import org.exolab.castor.xml.MarshalException;
import org.exolab.castor.xml.Marshaller;
import org.exolab.castor.xml.Unmarshaller;
import org.exolab.castor.xml.ValidationException;
import org.xml.sax.ContentHandler;

/**
 * Applicable tax element. This element allows for both percentages
 * and flat amounts. If one field is used, the other should be zero
 * since logically, taxes should be calculated in only one of the
 * two ways.
 * 
 * @version $Revision$ $Date$
 */
public class TaxType implements java.io.Serializable {


      //--------------------------/
     //- Class/Member Variables -/
    //--------------------------/

    /**
     * Used to indicate if the amount is inclusive or exclusive of
     * other charges, such as taxes, or is cumulative (amounts have
     * been added to each other).
     */
    private golfCourse.translations.castor.types.AmountDeterminationType _type;

    /**
     * Code identifying the fee (e.g.,agency fee, municipality
     * fee). Refer to OTA Code List Fee Tax Type (FTT).
     *  
     */
    private java.lang.String _code;

    /**
     * Fee percentage; if zero, assume use of the Amount attribute
     * (Amount or Percent must be a zero value).
     */
    private java.math.BigDecimal _percent;

    /**
     * Field _amount
     */
    private java.math.BigDecimal _amount;

    /**
     * The code specifying a monetary unit. Use ISO 4217, three
     * alpha code.
     */
    private java.lang.String _currencyCode;

    /**
     * Indicates the number of decimal places for a particular
     * currency. This is equivalent to the ISO 4217 standard "minor
     * unit". Typically used when the amount provided includes the
     * minor unit of currency without a decimal point (e.g., USD
     * 8500 needs DecimalPlaces="2" to represent $85).
     */
    private int _decimalPlaces;

    /**
     * keeps track of state for field: _decimalPlaces
     */
    private boolean _has_decimalPlaces;

    /**
     * Indicates the starting date.
     */
    private org.exolab.castor.types.Date _effectiveDate;

    /**
     * Indicates the ending date.
     */
    private org.exolab.castor.types.Date _expireDate;

    /**
     * This is the unit for which the charge applies (e.g. room,
     * person, seat). Refer to OTA Code List Charge Type (CHG).
     */
    private java.lang.String _chargeUnit;

    /**
     * This is the timeframe used to apply the charge during the
     * course of the reservation (e.g. Daily, Weekly, Stay). Refer
     * to OTA Code List Charge Type (CHG).
     */
    private java.lang.String _chargeFrequency;

    /**
     * Number of units permitted before charges are applied (e.g.,
     * more than 4 persons).
     */
    private int _chargeUnitExempt;

    /**
     * keeps track of state for field: _chargeUnitExempt
     */
    private boolean _has_chargeUnitExempt;

    /**
     * ChargeFrequency exemptions before charges are applied (e.g.
     * after 2 nights).
     */
    private int _chargeFrequencyExempt;

    /**
     * keeps track of state for field: _chargeFrequencyExempt
     */
    private boolean _has_chargeFrequencyExempt;

    /**
     * Maximum number of Units for which the charge will be applied
     * (e.g., waive charges above 10 rooms).
     */
    private int _maxChargeUnitApplies;

    /**
     * keeps track of state for field: _maxChargeUnitApplies
     */
    private boolean _has_maxChargeUnitApplies;

    /**
     * Maximum number of times the charge will be applied (e.g.
     * waive charges above 30 nights).
     */
    private int _maxChargeFrequencyApplies;

    /**
     * keeps track of state for field: _maxChargeFrequencyApplies
     */
    private boolean _has_maxChargeFrequencyApplies;

    /**
     * Text description of the taxes in a given language.
     */
    private java.util.Vector _taxDescriptionList;


      //----------------/
     //- Constructors -/
    //----------------/

    public TaxType() {
        super();
        _taxDescriptionList = new Vector();
    } //-- golfCourse.translations.castor.TaxType()


      //-----------/
     //- Methods -/
    //-----------/

    /**
     * Method addTaxDescription
     * 
     * @param vTaxDescription
     */
    public void addTaxDescription(golfCourse.translations.castor.TaxDescription vTaxDescription)
        throws java.lang.IndexOutOfBoundsException
    {
        if (!(_taxDescriptionList.size() < 5)) {
            throw new IndexOutOfBoundsException();
        }
        _taxDescriptionList.addElement(vTaxDescription);
    } //-- void addTaxDescription(golfCourse.translations.castor.TaxDescription) 

    /**
     * Method addTaxDescription
     * 
     * @param index
     * @param vTaxDescription
     */
    public void addTaxDescription(int index, golfCourse.translations.castor.TaxDescription vTaxDescription)
        throws java.lang.IndexOutOfBoundsException
    {
        if (!(_taxDescriptionList.size() < 5)) {
            throw new IndexOutOfBoundsException();
        }
        _taxDescriptionList.insertElementAt(vTaxDescription, index);
    } //-- void addTaxDescription(int, golfCourse.translations.castor.TaxDescription) 

    /**
     * Method deleteChargeFrequencyExempt
     */
    public void deleteChargeFrequencyExempt()
    {
        this._has_chargeFrequencyExempt= false;
    } //-- void deleteChargeFrequencyExempt() 

    /**
     * Method deleteChargeUnitExempt
     */
    public void deleteChargeUnitExempt()
    {
        this._has_chargeUnitExempt= false;
    } //-- void deleteChargeUnitExempt() 

    /**
     * Method deleteDecimalPlaces
     */
    public void deleteDecimalPlaces()
    {
        this._has_decimalPlaces= false;
    } //-- void deleteDecimalPlaces() 

    /**
     * Method deleteMaxChargeFrequencyApplies
     */
    public void deleteMaxChargeFrequencyApplies()
    {
        this._has_maxChargeFrequencyApplies= false;
    } //-- void deleteMaxChargeFrequencyApplies() 

    /**
     * Method deleteMaxChargeUnitApplies
     */
    public void deleteMaxChargeUnitApplies()
    {
        this._has_maxChargeUnitApplies= false;
    } //-- void deleteMaxChargeUnitApplies() 

    /**
     * Method enumerateTaxDescription
     */
    public java.util.Enumeration enumerateTaxDescription()
    {
        return _taxDescriptionList.elements();
    } //-- java.util.Enumeration enumerateTaxDescription() 

    /**
     * Returns the value of field 'amount'.
     * 
     * @return the value of field 'amount'.
     */
    public java.math.BigDecimal getAmount()
    {
        return this._amount;
    } //-- java.math.BigDecimal getAmount() 

    /**
     * Returns the value of field 'chargeFrequency'. The field
     * 'chargeFrequency' has the following description: This is the
     * timeframe used to apply the charge during the course of the
     * reservation (e.g. Daily, Weekly, Stay). Refer to OTA Code
     * List Charge Type (CHG).
     * 
     * @return the value of field 'chargeFrequency'.
     */
    public java.lang.String getChargeFrequency()
    {
        return this._chargeFrequency;
    } //-- java.lang.String getChargeFrequency() 

    /**
     * Returns the value of field 'chargeFrequencyExempt'. The
     * field 'chargeFrequencyExempt' has the following description:
     * ChargeFrequency exemptions before charges are applied (e.g.
     * after 2 nights).
     * 
     * @return the value of field 'chargeFrequencyExempt'.
     */
    public int getChargeFrequencyExempt()
    {
        return this._chargeFrequencyExempt;
    } //-- int getChargeFrequencyExempt() 

    /**
     * Returns the value of field 'chargeUnit'. The field
     * 'chargeUnit' has the following description: This is the unit
     * for which the charge applies (e.g. room, person, seat).
     * Refer to OTA Code List Charge Type (CHG).
     * 
     * @return the value of field 'chargeUnit'.
     */
    public java.lang.String getChargeUnit()
    {
        return this._chargeUnit;
    } //-- java.lang.String getChargeUnit() 

    /**
     * Returns the value of field 'chargeUnitExempt'. The field
     * 'chargeUnitExempt' has the following description: Number of
     * units permitted before charges are applied (e.g., more than
     * 4 persons).
     * 
     * @return the value of field 'chargeUnitExempt'.
     */
    public int getChargeUnitExempt()
    {
        return this._chargeUnitExempt;
    } //-- int getChargeUnitExempt() 

    /**
     * Returns the value of field 'code'. The field 'code' has the
     * following description: Code identifying the fee (e.g.,agency
     * fee, municipality fee). Refer to OTA Code List Fee Tax Type
     * (FTT).
     *  
     * 
     * @return the value of field 'code'.
     */
    public java.lang.String getCode()
    {
        return this._code;
    } //-- java.lang.String getCode() 

    /**
     * Returns the value of field 'currencyCode'. The field
     * 'currencyCode' has the following description: The code
     * specifying a monetary unit. Use ISO 4217, three alpha code.
     * 
     * @return the value of field 'currencyCode'.
     */
    public java.lang.String getCurrencyCode()
    {
        return this._currencyCode;
    } //-- java.lang.String getCurrencyCode() 

    /**
     * Returns the value of field 'decimalPlaces'. The field
     * 'decimalPlaces' has the following description: Indicates the
     * number of decimal places for a particular currency. This is
     * equivalent to the ISO 4217 standard "minor unit". Typically
     * used when the amount provided includes the minor unit of
     * currency without a decimal point (e.g., USD 8500 needs
     * DecimalPlaces="2" to represent $85).
     * 
     * @return the value of field 'decimalPlaces'.
     */
    public int getDecimalPlaces()
    {
        return this._decimalPlaces;
    } //-- int getDecimalPlaces() 

    /**
     * Returns the value of field 'effectiveDate'. The field
     * 'effectiveDate' has the following description: Indicates the
     * starting date.
     * 
     * @return the value of field 'effectiveDate'.
     */
    public org.exolab.castor.types.Date getEffectiveDate()
    {
        return this._effectiveDate;
    } //-- org.exolab.castor.types.Date getEffectiveDate() 

    /**
     * Returns the value of field 'expireDate'. The field
     * 'expireDate' has the following description: Indicates the
     * ending date.
     * 
     * @return the value of field 'expireDate'.
     */
    public org.exolab.castor.types.Date getExpireDate()
    {
        return this._expireDate;
    } //-- org.exolab.castor.types.Date getExpireDate() 

    /**
     * Returns the value of field 'maxChargeFrequencyApplies'. The
     * field 'maxChargeFrequencyApplies' has the following
     * description: Maximum number of times the charge will be
     * applied (e.g. waive charges above 30 nights).
     * 
     * @return the value of field 'maxChargeFrequencyApplies'.
     */
    public int getMaxChargeFrequencyApplies()
    {
        return this._maxChargeFrequencyApplies;
    } //-- int getMaxChargeFrequencyApplies() 

    /**
     * Returns the value of field 'maxChargeUnitApplies'. The field
     * 'maxChargeUnitApplies' has the following description:
     * Maximum number of Units for which the charge will be applied
     * (e.g., waive charges above 10 rooms).
     * 
     * @return the value of field 'maxChargeUnitApplies'.
     */
    public int getMaxChargeUnitApplies()
    {
        return this._maxChargeUnitApplies;
    } //-- int getMaxChargeUnitApplies() 

    /**
     * Returns the value of field 'percent'. The field 'percent'
     * has the following description: Fee percentage; if zero,
     * assume use of the Amount attribute (Amount or Percent must
     * be a zero value).
     * 
     * @return the value of field 'percent'.
     */
    public java.math.BigDecimal getPercent()
    {
        return this._percent;
    } //-- java.math.BigDecimal getPercent() 

    /**
     * Method getTaxDescription
     * 
     * @param index
     */
    public golfCourse.translations.castor.TaxDescription getTaxDescription(int index)
        throws java.lang.IndexOutOfBoundsException
    {
        //-- check bounds for index
        if ((index < 0) || (index > _taxDescriptionList.size())) {
            throw new IndexOutOfBoundsException();
        }
        
        return (golfCourse.translations.castor.TaxDescription) _taxDescriptionList.elementAt(index);
    } //-- golfCourse.translations.castor.TaxDescription getTaxDescription(int) 

    /**
     * Method getTaxDescription
     */
    public golfCourse.translations.castor.TaxDescription[] getTaxDescription()
    {
        int size = _taxDescriptionList.size();
        golfCourse.translations.castor.TaxDescription[] mArray = new golfCourse.translations.castor.TaxDescription[size];
        for (int index = 0; index < size; index++) {
            mArray[index] = (golfCourse.translations.castor.TaxDescription) _taxDescriptionList.elementAt(index);
        }
        return mArray;
    } //-- golfCourse.translations.castor.TaxDescription[] getTaxDescription() 

    /**
     * Method getTaxDescriptionCount
     */
    public int getTaxDescriptionCount()
    {
        return _taxDescriptionList.size();
    } //-- int getTaxDescriptionCount() 

    /**
     * Returns the value of field 'type'. The field 'type' has the
     * following description: Used to indicate if the amount is
     * inclusive or exclusive of other charges, such as taxes, or
     * is cumulative (amounts have been added to each other).
     * 
     * @return the value of field 'type'.
     */
    public golfCourse.translations.castor.types.AmountDeterminationType getType()
    {
        return this._type;
    } //-- golfCourse.translations.castor.types.AmountDeterminationType getType() 

    /**
     * Method hasChargeFrequencyExempt
     */
    public boolean hasChargeFrequencyExempt()
    {
        return this._has_chargeFrequencyExempt;
    } //-- boolean hasChargeFrequencyExempt() 

    /**
     * Method hasChargeUnitExempt
     */
    public boolean hasChargeUnitExempt()
    {
        return this._has_chargeUnitExempt;
    } //-- boolean hasChargeUnitExempt() 

    /**
     * Method hasDecimalPlaces
     */
    public boolean hasDecimalPlaces()
    {
        return this._has_decimalPlaces;
    } //-- boolean hasDecimalPlaces() 

    /**
     * Method hasMaxChargeFrequencyApplies
     */
    public boolean hasMaxChargeFrequencyApplies()
    {
        return this._has_maxChargeFrequencyApplies;
    } //-- boolean hasMaxChargeFrequencyApplies() 

    /**
     * Method hasMaxChargeUnitApplies
     */
    public boolean hasMaxChargeUnitApplies()
    {
        return this._has_maxChargeUnitApplies;
    } //-- boolean hasMaxChargeUnitApplies() 

    /**
     * Method isValid
     */
    public boolean isValid()
    {
        try {
            validate();
        }
        catch (org.exolab.castor.xml.ValidationException vex) {
            return false;
        }
        return true;
    } //-- boolean isValid() 

    /**
     * Method marshal
     * 
     * @param out
     */
    public void marshal(java.io.Writer out)
        throws org.exolab.castor.xml.MarshalException, org.exolab.castor.xml.ValidationException
    {
        
        Marshaller.marshal(this, out);
    } //-- void marshal(java.io.Writer) 

    /**
     * Method marshal
     * 
     * @param handler
     */
    public void marshal(org.xml.sax.ContentHandler handler)
        throws java.io.IOException, org.exolab.castor.xml.MarshalException, org.exolab.castor.xml.ValidationException
    {
        
        Marshaller.marshal(this, handler);
    } //-- void marshal(org.xml.sax.ContentHandler) 

    /**
     * Method removeAllTaxDescription
     */
    public void removeAllTaxDescription()
    {
        _taxDescriptionList.removeAllElements();
    } //-- void removeAllTaxDescription() 

    /**
     * Method removeTaxDescription
     * 
     * @param index
     */
    public golfCourse.translations.castor.TaxDescription removeTaxDescription(int index)
    {
        java.lang.Object obj = _taxDescriptionList.elementAt(index);
        _taxDescriptionList.removeElementAt(index);
        return (golfCourse.translations.castor.TaxDescription) obj;
    } //-- golfCourse.translations.castor.TaxDescription removeTaxDescription(int) 

    /**
     * Sets the value of field 'amount'.
     * 
     * @param amount the value of field 'amount'.
     */
    public void setAmount(java.math.BigDecimal amount)
    {
        this._amount = amount;
    } //-- void setAmount(java.math.BigDecimal) 

    /**
     * Sets the value of field 'chargeFrequency'. The field
     * 'chargeFrequency' has the following description: This is the
     * timeframe used to apply the charge during the course of the
     * reservation (e.g. Daily, Weekly, Stay). Refer to OTA Code
     * List Charge Type (CHG).
     * 
     * @param chargeFrequency the value of field 'chargeFrequency'.
     */
    public void setChargeFrequency(java.lang.String chargeFrequency)
    {
        this._chargeFrequency = chargeFrequency;
    } //-- void setChargeFrequency(java.lang.String) 

    /**
     * Sets the value of field 'chargeFrequencyExempt'. The field
     * 'chargeFrequencyExempt' has the following description:
     * ChargeFrequency exemptions before charges are applied (e.g.
     * after 2 nights).
     * 
     * @param chargeFrequencyExempt the value of field
     * 'chargeFrequencyExempt'.
     */
    public void setChargeFrequencyExempt(int chargeFrequencyExempt)
    {
        this._chargeFrequencyExempt = chargeFrequencyExempt;
        this._has_chargeFrequencyExempt = true;
    } //-- void setChargeFrequencyExempt(int) 

    /**
     * Sets the value of field 'chargeUnit'. The field 'chargeUnit'
     * has the following description: This is the unit for which
     * the charge applies (e.g. room, person, seat). Refer to OTA
     * Code List Charge Type (CHG).
     * 
     * @param chargeUnit the value of field 'chargeUnit'.
     */
    public void setChargeUnit(java.lang.String chargeUnit)
    {
        this._chargeUnit = chargeUnit;
    } //-- void setChargeUnit(java.lang.String) 

    /**
     * Sets the value of field 'chargeUnitExempt'. The field
     * 'chargeUnitExempt' has the following description: Number of
     * units permitted before charges are applied (e.g., more than
     * 4 persons).
     * 
     * @param chargeUnitExempt the value of field 'chargeUnitExempt'
     */
    public void setChargeUnitExempt(int chargeUnitExempt)
    {
        this._chargeUnitExempt = chargeUnitExempt;
        this._has_chargeUnitExempt = true;
    } //-- void setChargeUnitExempt(int) 

    /**
     * Sets the value of field 'code'. The field 'code' has the
     * following description: Code identifying the fee (e.g.,agency
     * fee, municipality fee). Refer to OTA Code List Fee Tax Type
     * (FTT).
     *  
     * 
     * @param code the value of field 'code'.
     */
    public void setCode(java.lang.String code)
    {
        this._code = code;
    } //-- void setCode(java.lang.String) 

    /**
     * Sets the value of field 'currencyCode'. The field
     * 'currencyCode' has the following description: The code
     * specifying a monetary unit. Use ISO 4217, three alpha code.
     * 
     * @param currencyCode the value of field 'currencyCode'.
     */
    public void setCurrencyCode(java.lang.String currencyCode)
    {
        this._currencyCode = currencyCode;
    } //-- void setCurrencyCode(java.lang.String) 

    /**
     * Sets the value of field 'decimalPlaces'. The field
     * 'decimalPlaces' has the following description: Indicates the
     * number of decimal places for a particular currency. This is
     * equivalent to the ISO 4217 standard "minor unit". Typically
     * used when the amount provided includes the minor unit of
     * currency without a decimal point (e.g., USD 8500 needs
     * DecimalPlaces="2" to represent $85).
     * 
     * @param decimalPlaces the value of field 'decimalPlaces'.
     */
    public void setDecimalPlaces(int decimalPlaces)
    {
        this._decimalPlaces = decimalPlaces;
        this._has_decimalPlaces = true;
    } //-- void setDecimalPlaces(int) 

    /**
     * Sets the value of field 'effectiveDate'. The field
     * 'effectiveDate' has the following description: Indicates the
     * starting date.
     * 
     * @param effectiveDate the value of field 'effectiveDate'.
     */
    public void setEffectiveDate(org.exolab.castor.types.Date effectiveDate)
    {
        this._effectiveDate = effectiveDate;
    } //-- void setEffectiveDate(org.exolab.castor.types.Date) 

    /**
     * Sets the value of field 'expireDate'. The field 'expireDate'
     * has the following description: Indicates the ending date.
     * 
     * @param expireDate the value of field 'expireDate'.
     */
    public void setExpireDate(org.exolab.castor.types.Date expireDate)
    {
        this._expireDate = expireDate;
    } //-- void setExpireDate(org.exolab.castor.types.Date) 

    /**
     * Sets the value of field 'maxChargeFrequencyApplies'. The
     * field 'maxChargeFrequencyApplies' has the following
     * description: Maximum number of times the charge will be
     * applied (e.g. waive charges above 30 nights).
     * 
     * @param maxChargeFrequencyApplies the value of field
     * 'maxChargeFrequencyApplies'.
     */
    public void setMaxChargeFrequencyApplies(int maxChargeFrequencyApplies)
    {
        this._maxChargeFrequencyApplies = maxChargeFrequencyApplies;
        this._has_maxChargeFrequencyApplies = true;
    } //-- void setMaxChargeFrequencyApplies(int) 

    /**
     * Sets the value of field 'maxChargeUnitApplies'. The field
     * 'maxChargeUnitApplies' has the following description:
     * Maximum number of Units for which the charge will be applied
     * (e.g., waive charges above 10 rooms).
     * 
     * @param maxChargeUnitApplies the value of field
     * 'maxChargeUnitApplies'.
     */
    public void setMaxChargeUnitApplies(int maxChargeUnitApplies)
    {
        this._maxChargeUnitApplies = maxChargeUnitApplies;
        this._has_maxChargeUnitApplies = true;
    } //-- void setMaxChargeUnitApplies(int) 

    /**
     * Sets the value of field 'percent'. The field 'percent' has
     * the following description: Fee percentage; if zero, assume
     * use of the Amount attribute (Amount or Percent must be a
     * zero value).
     * 
     * @param percent the value of field 'percent'.
     */
    public void setPercent(java.math.BigDecimal percent)
    {
        this._percent = percent;
    } //-- void setPercent(java.math.BigDecimal) 

    /**
     * Method setTaxDescription
     * 
     * @param index
     * @param vTaxDescription
     */
    public void setTaxDescription(int index, golfCourse.translations.castor.TaxDescription vTaxDescription)
        throws java.lang.IndexOutOfBoundsException
    {
        //-- check bounds for index
        if ((index < 0) || (index > _taxDescriptionList.size())) {
            throw new IndexOutOfBoundsException();
        }
        if (!(index < 5)) {
            throw new IndexOutOfBoundsException();
        }
        _taxDescriptionList.setElementAt(vTaxDescription, index);
    } //-- void setTaxDescription(int, golfCourse.translations.castor.TaxDescription) 

    /**
     * Method setTaxDescription
     * 
     * @param taxDescriptionArray
     */
    public void setTaxDescription(golfCourse.translations.castor.TaxDescription[] taxDescriptionArray)
    {
        //-- copy array
        _taxDescriptionList.removeAllElements();
        for (int i = 0; i < taxDescriptionArray.length; i++) {
            _taxDescriptionList.addElement(taxDescriptionArray[i]);
        }
    } //-- void setTaxDescription(golfCourse.translations.castor.TaxDescription) 

    /**
     * Sets the value of field 'type'. The field 'type' has the
     * following description: Used to indicate if the amount is
     * inclusive or exclusive of other charges, such as taxes, or
     * is cumulative (amounts have been added to each other).
     * 
     * @param type the value of field 'type'.
     */
    public void setType(golfCourse.translations.castor.types.AmountDeterminationType type)
    {
        this._type = type;
    } //-- void setType(golfCourse.translations.castor.types.AmountDeterminationType) 

    /**
     * Method unmarshal
     * 
     * @param reader
     */
    public static java.lang.Object unmarshal(java.io.Reader reader)
        throws org.exolab.castor.xml.MarshalException, org.exolab.castor.xml.ValidationException
    {
        return (golfCourse.translations.castor.TaxType) Unmarshaller.unmarshal(golfCourse.translations.castor.TaxType.class, reader);
    } //-- java.lang.Object unmarshal(java.io.Reader) 

    /**
     * Method validate
     */
    public void validate()
        throws org.exolab.castor.xml.ValidationException
    {
        org.exolab.castor.xml.Validator validator = new org.exolab.castor.xml.Validator();
        validator.validate(this);
    } //-- void validate() 

}
