package golfCourse.translations.fromOTA;

import golfCourse.ontologies.jastor.contacts.Contacts;
import golfCourse.ontologies.jastor.contacts.ContactsFactory;
import golfCourse.translations.castor.Phone;

import com.hp.hpl.jena.ontology.OntModel;
import com.hp.hpl.jena.rdf.model.Resource;
import com.ibm.adtech.jastor.JastorException;

public class ContactTranslator {

	private OntModel model;
	
	public ContactTranslator(OntModel model)
	{
		this.model = model;
	}
	
	public Contacts translate(Phone phone, String golfCourseID) throws JastorException
	{
		if(model == null)
			return null;
		
		if(phone == null)
			return null;
		
		Resource r = model.createResource(Contacts.TYPE.getNameSpace() + golfCourseID + "_contact");
		Contacts contact = ContactsFactory.createContacts(r, model);
		
		contact.setAddress(phone.getPhoneNumber());

		return contact;
	}
}
