package golfCourse.translations.toOTA;

import golfCourse.communication.ontology.Condition;
import golfCourse.communication.ontology.Conditions;
import golfCourse.exceptions.TranslateException;
import golfCourse.translations.castor.Criteria;
import golfCourse.translations.castor.Criterion;
import golfCourse.translations.castor.OTA_GolfCourseSearchRQ;
import jade.util.leap.Iterator;

import java.io.StringWriter;
import java.io.Writer;
import java.math.BigDecimal;

import org.exolab.castor.xml.MarshalException;
import org.exolab.castor.xml.ValidationException;

public class GolfCourseSearchRQTranslator {
	
	public static String translateToOTA(Conditions conditions) throws TranslateException
	{
		OTA_GolfCourseSearchRQ ota = new OTA_GolfCourseSearchRQ();
		
		// TODO remove this
		ota.setVersion(new BigDecimal("1"));
		ota.setID("343");
		ota.setDetailResponse(false);
		
		Criteria criteria = translateCriteria(conditions);
		ota.setCriteria(criteria);
		
		Writer writer = new StringWriter();
		try {
			ota.marshal(writer);
		}
		catch(MarshalException e)
		{
			throw new TranslateException("Marshal exception " + e);
		}
		catch(ValidationException e2)
		{
			throw new TranslateException("Validation exception " + e2);
		}	
		
		return writer.toString();
	}

	private static Criteria translateCriteria(Conditions conditions)
	{
		Criteria criteria = new Criteria();
		
		for(Iterator iter = conditions.getAllConditions(); iter.hasNext();)
		{
			Condition condition = (Condition)iter.next();
			
			Criterion criterion = new Criterion();
			
			criterion.setName(condition.getName_());
			criterion.setOperation(condition.getOperation_());
			criterion.setRequired(condition.getRequired_());
			criterion.setValue(condition.getValueString());
			criteria.addCriterion(criterion);
		}
		return criteria;
	}
}
