package personalSystem.PersonalAgent;

import java.io.File;
import java.io.IOException;
import java.util.List;

import org.apache.commons.digester.Digester;
import org.xml.sax.SAXException;

public class ConditionsGenerator {

	private static final String STRING_TRUE = "true";
	
	public static golfCourse.communication.ontology.Conditions generateConditions() throws SAXException, IOException
	{
		
	   Digester digester = new Digester();
	   digester.setValidating( false );

	   digester.addObjectCreate( "conditions", Conditions.class );

	   digester.addObjectCreate( "conditions/condition", Condition.class );
	   digester.addBeanPropertySetter( "conditions/condition/name", "name" );
	   digester.addBeanPropertySetter( "conditions/condition/value", "value" );
	   digester.addBeanPropertySetter( "conditions/condition/operation", "operation" );
	   digester.addBeanPropertySetter( "conditions/condition/required", "required" );
	   digester.addSetNext( "conditions/condition", "addCondition" );

	   File input = new File(PersonalAgentProperties.CONDITIONS_FILE_PATH);
	   Conditions c = (Conditions)digester.parse( input );

	   return translateConditions(c);
	}

	private static golfCourse.communication.ontology.Conditions translateConditions(Conditions conditions) {
		golfCourse.communication.ontology.Conditions cons = new golfCourse.communication.ontology.Conditions();
		
		List conditionsList = conditions.getConditions();
		
		for(int i = 0; i < conditionsList.size(); i++) {
			Condition condition = (Condition)conditionsList.get(i);
			cons.addConditions(translateCondition(condition));
		}
		return cons;
	}
	
	private static golfCourse.communication.ontology.Condition translateCondition(Condition condition) {
		golfCourse.communication.ontology.Condition con = new golfCourse.communication.ontology.Condition();
		con.setName_(condition.getName());
		con.setOperation_(condition.getOperation());
		con.setValueString(condition.getValue());
		if(STRING_TRUE.equals(condition.getRequired()))
			con.setRequired_(true);
		else
			con.setRequired_(false);
		return con;
	}
}
