package personalSystem.PersonalAgent;

import golfCourse.communication.ontology.MapEntry;

import java.io.File;
import java.io.IOException;
import java.util.List;

import org.apache.commons.digester.Digester;
import org.xml.sax.SAXException;

public class MapGenerator {

	public static golfCourse.communication.ontology.Map generate() throws SAXException, IOException
	{
		Digester digester = new Digester();
	    digester.setValidating( false );

	    digester.addObjectCreate( "Map", Map.class );

	    digester.addObjectCreate( "Map/Element", Element.class );
	    digester.addBeanPropertySetter( "Map/Element/Key", "key" );
	    digester.addBeanPropertySetter( "Map/Element/Value", "value" );
	      
	    digester.addSetNext( "Map/Element", "addElement" );

	    File input = new File(PersonalAgentProperties.MAP_FILE_PATH);
	    Map map = (Map)digester.parse( input );
	         
	    return translateMap(map);
	}
	
	private static golfCourse.communication.ontology.Map translateMap(Map map) {
		golfCourse.communication.ontology.Map map2 = new golfCourse.communication.ontology.Map();
		
		List elements = map.getElements();
		
		for(int i = 0; i < elements.size(); i++) {
			MapEntry mapEntry = new MapEntry();
			Element elem = (Element)elements.get(i);
			mapEntry.setKey(elem.getKey());
			mapEntry.setValue(elem.getValue());
			map2.addHasEntry(mapEntry);
		}
		
		return map2;
	}
	
	/*public static Map generate()
	{
		Map map = new Map();
		
		MapEntry entry = new MapEntry();
		entry.setKey(GolfCourseAvailMapVocabulary.GOLF_COURSE_ID);
		entry.setValue("wqe32");
		map.addHasEntry(entry);
		
		entry = new MapEntry();
		entry.setKey(GolfCourseAvailMapVocabulary.AMOUNT);
		entry.setValue("123");
		map.addHasEntry(entry);
		
		entry = new MapEntry();
		entry.setKey(GolfCourseAvailMapVocabulary.CURRENCY_CODE);
		entry.setValue("PLN");
		map.addHasEntry(entry);
		
		entry = new MapEntry();
		entry.setKey(GolfCourseAvailMapVocabulary.START_DATE);
		Date date = new Date();
		entry.setValue(date.toLocaleString());
		map.addHasEntry(entry);
		
		entry = new MapEntry();
		entry.setKey(GolfCourseAvailMapVocabulary.END_DATE);
		entry.setValue(date.toLocaleString());
		map.addHasEntry(entry);
		
		entry = new MapEntry();
		entry.setKey(GolfCourseAvailMapVocabulary.MAX_PRICE);
		entry.setValue("345");
		map.addHasEntry(entry);
		
		entry = new MapEntry();
		entry.setKey(GolfCourseAvailMapVocabulary.NUMBER_OF_HOLES);
		entry.setValue("9");
		map.addHasEntry(entry);
		
		entry = new MapEntry();
		entry.setKey(GolfCourseAvailMapVocabulary.NUMBER_OF_TIMES);
		entry.setValue("2");
		map.addHasEntry(entry);
		
		entry = new MapEntry();
		entry.setKey(GolfCourseAvailMapVocabulary.NUMBER_OF_GOLFERS);
		entry.setValue("5");
		map.addHasEntry(entry);
		
		return map;
	}*/
}
